<div class="container-fluid" style="margin-top: 10px">
  <form [formGroup]="expenditureRequestForm">
    <div class="card">
      <div class="card-header bg-info text-white">Expenditure Request</div>
      <div class="card-body">
        <div class="row">
          <div class="col-sm-6">
            <div class="row">
              <div class="col-sm-6">
                <div class="form-group">
                  <label>Date<span class="required">*</span></label><br>
                  <p-calendar name="date"
                              formControlName="requestDate"
                              [minDate]="minDate"
                              [showIcon]="true"
                              required
                  >
                  </p-calendar>
                </div>
              </div>
              <div class="col-sm-6">
                <div class="form-group">
                  <label for="expType">Expenditure Type<span class="required">*</span></label>
                  <select id="expType"
                          class="form-control"
                          formControlName="expenditureType"
                          [ngClass]="{ 'is-invalid': submitted && f.expenditureType.errors }"
                          name="expType"
                          required>
                    <option *ngFor="let event of (expenditureTypes); let i = index"
                            [ngValue]="(expenditureTypes)[i]"
                    >{{(expenditureTypes)[i].type + ' ( ' + (expenditureTypes)[i].value + ' )'}}</option>
                  </select>
                  <div *ngIf="submitted && f.expenditureType.errors" class="invalid-feedback">
                    <div *ngIf="f.expenditureType.errors.required">Expenditure Type is Required.</div>
                  </div>
                </div>
              </div>
              <div class="col-sm-6">
                <div class="form-group">
                  <label for="fiscalYear">Fiscal Year<span class="required">*</span></label>
                  <select id="fiscalYear"
                          class="form-control"
                          name="fiscalYear"
                          [ngClass]="{ 'is-invalid': submitted && f.fiscalYearId.errors }"
                          formControlName="fiscalYearId"
                          required>
                    <option *ngFor="let event of (fiscalYears); let i = index"
                            [ngValue]="(fiscalYears)[i]"
                    >{{(fiscalYears)[i].year}}</option>
                  </select>
                  <div *ngIf="submitted && f.fiscalYearId.errors" class="invalid-feedback">
                    <div *ngIf="f.fiscalYearId.errors.required">Fiscal Year is required</div>
                  </div>
                </div>
              </div>
              <div class="col-sm-6">
                <div class="form-group">
                  <label for="month">Month<span class="required">*</span></label>
                  <select id="month"
                          class="form-control"
                          name="expType"
                          formControlName="month"
                          [ngClass]="{ 'is-invalid': submitted && f.month.errors }"
                          required
                  >
                    <option *ngFor="let event of (months); let i = index"
                            [ngValue]="(months)[i].months"
                    >{{ (months)[i].months }}</option>
                  </select>
                  <div *ngIf="submitted && f.month.errors" class="invalid-feedback">
                    <div *ngIf="f.month.errors.required">Month is Required.</div>
                  </div>
                </div>
              </div>
            </div>

          </div>
          <div class="col-sm-6">
            <div class="row">
              <div class="col-sm-6">
                <div class="form-group">
                  <label for="amount">Amount ( Inclusive of VAT )<span class="required">*</span></label>
                  <input type="number"
                         class="form-control"
                         id="amount"
                         (ngModelChange)="renderProposedExpenses($event)"
                         placeholder="amount"
                         [ngClass]="{ 'is-invalid': submitted && f.amount.errors }"
                         formControlName="amount"
                         required
                  >
                  <div *ngIf="submitted && f.amount.errors" class="invalid-feedback">
                    <div *ngIf="f.amount.errors.required">Amount is required</div>
                    <div *ngIf="f.amount.errors.max">Invalid Amount. Please, check.</div>
                  </div>
                  <span *ngIf="expenditureRequestForm.value.amount" style="color: green">
                {{expenditureRequestForm.value.amount | numberToWords}}
              </span>
                </div>
              </div>
              <div class="col-sm-6">
                <div class="form-group">
                  <label for="advance">Advance Amount</label>
                  <input type="number"
                         class="form-control"
                         id="advance"
                         [maxLength]="9"
                         placeholder="Advance Amount"
                         formControlName="advanceAmount">
                  <span *ngIf="expenditureRequestForm.value.advanceAmount" style="color: green">
                {{expenditureRequestForm.value.advanceAmount | numberToWords}}
              </span>
                </div>
              </div>
            </div>
            <div class="form-group">
              <label for="customFile">Choose file</label>
              <input type="file"
                     formControlName="file"
                     class="form-control"
                     id="customFile"
                     multiple
                     (change)="onFileChange($event)"
              >
              <span style="color: red" *ngIf="showFileValidationMessage">Unsupported file format.</span>
            </div>

          </div>
        </div>
        <div class="row">
          <div class="col-sm-6">
            <div class="form-group">
              <label for="subject">Subject<span class="required">*</span></label>
              <input type="text"
                     class="form-control"
                     id="subject"
                     [ngClass]="{ 'is-invalid': submitted && f.subject.errors }"
                     placeholder="Enter Subject [min lenght 10 characters]"
                     formControlName="subject"
                     required>
              <div *ngIf="submitted && f.subject.errors" class="invalid-feedback">
                <div *ngIf="f.subject.errors.required">Subject is required</div>
              </div>
            </div>
          </div>
          <div class="col-sm-6">
            <div class="form-group">
              <label for="link">Link ( As Reference )</label>
              <textarea type="text"
                        class="form-control"
                        id="link"
                        rows="3"
                        placeholder="For Multiple Reference link, Please, use space after each link"
                        formControlName="link">
                </textarea>
            </div>
          </div>
        </div>


        <div class="form-group">
          <label for="justification">Justification<span class="required">*</span></label>
          <textarea class="form-control"
                    rows="3"
                    id="justification"
                    placeholder="Enter Justification ( Max length 1000 )"
                    maxlength="1000"
                    [ngClass]="{ 'is-invalid': submitted && f.justification.errors }"
                    formControlName="justification"
                    required
          >
              </textarea>
          <div *ngIf="submitted && f.justification.errors" class="invalid-feedback">
            <div *ngIf="f.justification.errors.required">Justification is required</div>
          </div>
        </div>

        <div class="form-group">
          <label for="expenseDetail">Expense Detail<span class="required">*</span></label>

          <ckeditor [editor]="Editor"
                    id="expenseDetail"
                    name="expenseDetail"
                    tagName="textarea"
                    [editor]="Editor"
                    placeholder="Enter Description ( Max length 1000 )"
                    formControlName="expenseDetail"></ckeditor>
          <div *ngIf="submitted && f.expenseDetail.errors" class="invalid-feedback">
            <div *ngIf="f.expenseDetail.errors.required">Expense Detail is required</div>
          </div>
        </div>
      </div>

      <hr>
      <div class="card-body">
        <div class="row">
          <div class="col-sm-6">
            <div class="form-group">
              <label for="supporter">Select Supporter </label><br>
              <p-autoComplete formControlName="supporters"
                              id="supporter"
                              class="ui-fluid"
                              [inputStyle]="{'width':'180px'}"
                              [suggestions]="supporter"
                              (completeMethod)="searchSupporter($event)"
                              [minLength]="5"
                              field="fullName"
                              [scrollHeight]="200"
                              placeholder="Enter Name or Employee Id"
                              [multiple]="true"
                              [ngClass]="{ 'is-invalid': submitted && f.supporters.errors }"
              >
                <ng-template let-value pTemplate="selectedItem">
                  <span style="font-size:18px">{{value.fullName + '( ' + value.designation + ') '}}</span>
                </ng-template>
              </p-autoComplete>
            </div>
          </div>
          <div class="col-sm-6">
            <div class="form-group">
              <label for="approver">Select Approver <span class="required">*</span> </label><br>
              <p-autoComplete formControlName="approvers"
                              id="approver"
                              class="ui-fluid"
                              [inputStyle]="{'width':'180px'}"
                              [suggestions]="approver"
                              (completeMethod)="searchApprover($event)"
                              [minLength]="5"
                              field="fullName"
                              [scrollHeight]="200"
                              [ngClass]="{ 'is-invalid': submitted && f.approvers.errors }"
                              placeholder="Enter Name or Employee Id"
                              [multiple]="true"
                              required>
                <ng-template let-value pTemplate="selectedItem">
                  <span style="font-size:18px">{{value.fullName + '( ' + value.designation + ') '}}</span>
                </ng-template>
              </p-autoComplete>
              <div *ngIf="submitted && f.approvers.errors" class="invalid-feedback">
                <div *ngIf="f.approvers.errors.required">Approver is required</div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="card-body">
        <span *ngIf="showAmountMismatchMessage" style="color: red;"> Total proposed expenses amount is not equal to bill amount.
          Please, verify. </span>
        <table class="table table-bordered" formArrayName="proposedExpenseRequest">
          <tr>
            <th colspan="4">Proposed Expenses<span class="required">*</span></th>
            <th width="5%">
              <button type="button"
                      (click)="addProposedExpenses()"
                      class="btn btn-primary btn-xs">
                <i class="pi pi-plus-circle"></i>
              </button>
            </th>
          </tr>
          <tr *ngFor="let expense of proposedExpenseRequest().controls; let i=index" [formGroupName]="i">
            <td style="width: 20%">
              Debit Branch <span class="required">*</span>
              <select id="debitBranch"
                      class="form-control"
                      name="debitBranch"
                      formControlName="debitBranchId"
                      required
              >
                <option *ngFor="let event of (allBranch); let i = index"
                        [ngValue]="(allBranch)[i].branchId"
                >{{(allBranch)[i].name + ' ( ' + (allBranch)[i].code + ' )'}}</option>
              </select>
            </td>
            <td>
              Debit Account<span class="required">*</span>
              <app-dynamic-dialog
                *ngIf="this.expenditureRequestForm.value.fiscalYearId
                && this.expenditureRequestForm.value.month
                && this.expenditureRequestForm.value.proposedExpenseRequest[i].debitBranchId
                && this.expenditureRequestForm.value.proposedExpenseRequest[i].accountHeadId"
                [popupType]="'budget-detail'"
                [fiscalYearId]="this.expenditureRequestForm.value.fiscalYearId.id"
                [month]="this.expenditureRequestForm.value.month"
                [branchId]="this.expenditureRequestForm.value.proposedExpenseRequest[i].debitBranchId"
                [accountHeadId]="this.expenditureRequestForm.value.proposedExpenseRequest[i].accountHeadId"
              ></app-dynamic-dialog>

              <select id="accountHead"
                      class="form-control"
                      name="fiscalYear"
                      formControlName="accountHeadId"
                      required>
                <option *ngFor="let event of (accountHeads); let i = index"
                        [ngValue]="(accountHeads)[i].accountHeadId"
                >{{(accountHeads)[i].description}}</option>
              </select>
            </td>
            <td>
              Amount<span class="required">*</span>
              <input type="number"
                     formControlName="amount"
                     class="form-control"
                     required>
              <span *ngIf="this.expenditureRequestForm.value.proposedExpenseRequest[i].amount" style="color: green">
                      {{this.expenditureRequestForm.value.proposedExpenseRequest[i].amount | numberToWords}}
                    </span>
            </td>
            <td>
              Description<span class="required">*</span>
              <input type="text"
                     formControlName="expenseDescription"
                     class="form-control"
                     placeholder="Max Lenght 45 Characters"
                     maxlength="45"
                     required>
            </td>
            <td>
              <button (click)="removeProposedExpenses(i)"
                      class="btn btn-danger btn-xs">
                <i class="pi pi-trash"></i>
              </button>
            </td>
          </tr>
        </table>
      </div>
      <div class="card-footer">
        <div class="row">
          <div class="col-sm-6">
            <button type="button"
                    class="btn btn-success btn-block"
                    (click)="confirmCreateRequest()"
            >Submit
            </button>
          </div>
          <div class="col-sm-6">
            <button type="button" class="btn btn-danger btn-block"
                    (click)="cancel()">Cancel
            </button>
          </div>
        </div>
      </div>
    </div>
  </form>
</div>

<p-dialog [(visible)]="showPreApprovaldDetail"
          [modal]="true"
          [responsive]="true"
          [maximizable]="true"
          [baseZIndex]="100000"
          [style]="{width: '790px', height: 'auto'}">
  <p-header>
    <h3 style="font-weight: 800;color: #454545;float: left; margin: 0;">Confirm, Pre Approval Request Detail</h3>
  </p-header>

  <div class="row">
    <div class="col-md-12 mt-3">
      <div class="col-md-6 form-group float-left">
        <label>Requested Date :</label>
        <p>{{ expenditureRequestForm.value.requestDate | date: 'short' }}</p>
      </div>

      <div class="col-md-6 form-group float-left" *ngIf="expenditureRequestForm.value.expenditureType">
        <label>Expenditure Type :</label>
        <p>{{expenditureRequestForm.value.expenditureType}}</p>
      </div>

      <div class="col-md-6 form-group float-left" *ngIf="expenditureRequestForm.value.amount">
        <label>Amount :</label>
        <p>{{expenditureRequestForm.value.amount}}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Subject :</label>
        <p>{{expenditureRequestForm.value.subject}}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Month:</label>
        <p>{{expenditureRequestForm.value.month}}</p>
      </div>

      <div class="col-md-6 form-group float-left" *ngIf="expenditureRequestForm.value.fiscalYearId">
        <label>Fiscal Year :</label>
        <p>{{expenditureRequestForm.value.fiscalYearId.year}}</p>
      </div>

      <!--      <div class="col-md-6 form-group float-left">-->
      <!--        <label>Expense Detail :</label>-->
      <!--        <p>{{expenditureRequestForm.value.expenseDetail}}</p>-->
      <!--      </div>-->

      <div class="col-md-6 form-group float-left">
        <label>Justification:</label>
        <p>{{expenditureRequestForm.value.justification }}</p>
      </div>
      <div class="col-md-6 form-group float-left" *ngIf="expenditureRequestForm.value.link">
        <label>Link:</label>
        <p style="overflow: auto">{{expenditureRequestForm.value.link }}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Approved By:</label>
        <p *ngFor="let approvers of expenditureRequestForm.value.approvers">
          {{approvers.fullName + ' ( ' + approvers.designation + ' )'}}</p>
      </div>

      <div class="col-md-6 form-group float-left">
        <label>Supported By:</label>
        <p *ngFor="let supporters of expenditureRequestForm.value.supporters">
          {{supporters.fullName + ' ( ' + supporters.designation + ' )'}}</p>
      </div>
    </div>
    <hr>
    <table class="table">
      <thead>
      <tr>
        <th scope="col">Debit Account</th>
        <th scope="col">Amount</th>
        <th scope="col">Expense Description</th>
      </tr>
      </thead>
      <tbody>
      <tr *ngFor="let expenses of  expenditureRequestForm.value.proposedExpenseRequest">
        <td>{{expenses.accountHeadId.description}}</td>
        <td>{{expenses.amount}}</td>
        <td>{{expenses.expenseDescription}}</td>
      </tr>
      </tbody>
    </table>
  </div>
  <footer>
    <div class="row">
      <div class="col-md-12">
        <div class="col-md-12 mb-3">
          <button class="btn btn-sm btn-success float-right"
                  type="submit"
                  [disabled]="loading"
                  (click)="onSubmit()">
            <span *ngIf="loading" class="spinner-border spinner-border-sm mr-1"></span>
            Confirm
          </button>
          <button class="btn btn-sm btn-danger btn-outline- ml-3 float-right"
                  type="button"
                  [disabled]="loading"
                  (click)="showPreApprovaldDetail=false">
            Cancel
          </button>
        </div>
      </div>
    </div>
  </footer>
</p-dialog>
